

import { EventTouch, Node, Toggle, Tween, Vec3, _decorator, easing, tween } from "cc";
import { oops } from "../../../../../extensions/oops-plugin-framework/assets/core/Oops";
import { ecs } from "../../../../../extensions/oops-plugin-framework/assets/libs/ecs/ECS";
import { CCComp } from "../../../../../extensions/oops-plugin-framework/assets/module/common/CCComp";
import { UIID } from "../../common/config/GameUIConfig";
import { SingletonModuleComp } from "../../common/SingletonModuleComp";
import { CheckpointSkinItemViewComp } from "./CheckpointSkinItem";


const { ccclass, property } = _decorator;

/** 角色换装界面 */
@ccclass('CheckpointSkinViewComp')
@ecs.register('CheckpointSkinView', false)
export class CheckpointSkinViewComp extends CCComp {

    @property({ type: [CheckpointSkinItemViewComp], visible: true, tooltip: '关卡item' })
    itemArr: Array<CheckpointSkinItemViewComp> = []


    private btnClose

    onAdded(args: any) {
        console.log(args);

    }

    onLoad() {
        this.btnClose = this.node.getChildByPath("BG/btn_close")
        this.btnClose.on(Node.EventType.TOUCH_END, this.onTouchEnd, this);

        const window = this.node.getChildByName("BG")
        window.setScale(new Vec3(0, 0, 1));
        // 使用Tween来实现动画效果
        Tween.stopAllByTarget(window); // 停止该节点上的所有其他Tween
        tween(window)
            // .delay(0.1)
            .to(0.3, { scale: new Vec3(0.5, 0.5, 1) }, { easing: easing.backOut }) // 缩放动画
            .start(); // 开始动画
    }

    private onTouchEnd(event: EventTouch) {
        switch (event.target.name) {
            case "btn_close":
                oops.gui.remove(UIID.Skin);
                break;
        }

        event.propagationStopped = true;
    }

    reset() {
        this.node.destroy();
    }
}